; 
    include \masm32\include\masm32rt.inc
; 

    .686p
    .MMX
    .XMM

    include bmtemplate.inc

  ; -------------------------
  ; test algorithm prototypes
  ; -------------------------
    utoa PROTO :DWORD,:DWORD
    utoa_ex PROTO :DWORD,:DWORD

    SetAlgoName MACRO vname,quoted_text
    LOCAL tname
      tname db quoted_text,0
      vname dd tname
    ENDM

  .data
  ; ------------------------------------
  ; set the algorithm display names here
  ; ------------------------------------
    SetAlgoName nam1,"utoa  "
    SetAlgoName nam2,"utoa_ex  "
    SetAlgoName nam3,"udw2str  "
    SetAlgoName nam4,"msvc ustr$  "

; 

    .code

  ; ----------------------------------
  ; The test algorithms are added here
  ; ----------------------------------
    include algos.asm

start:

    invoke load_common_controls
    GLOBAL hInstance dd ?
    mov hInstance, rv(GetModuleHandle, NULL)

  ; -------------------------------------------
  ; Call the dialog box from the resource file
  ; -------------------------------------------
    invoke DialogBoxParam,hInstance,100,0,ADDR WndProc,0

    invoke ExitProcess,eax

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

      LOCAL pbuf  :DWORD
      LOCAL buffer[128]:BYTE

      STRING dlgTitle," Benchmark DWORD to ASCII Algorithms"
      GLOBAL hWnd       dd ?

    ; -----------------------
    ; Dialog control handles
    ; -----------------------
      GLOBAL hButn1     dd ?
      GLOBAL hButn2     dd ?

      GLOBAL algoname1  dd ?
      GLOBAL algoname2  dd ?
      GLOBAL algoname3  dd ?
      GLOBAL algoname4  dd ?

      GLOBAL rslt1      dd ?
      GLOBAL rslt2      dd ?
      GLOBAL rslt3      dd ?
      GLOBAL rslt4      dd ?

      GLOBAL bar1       dd ?
      GLOBAL bar2       dd ?
      GLOBAL bar3       dd ?
      GLOBAL bar4       dd ?

      GLOBAL indicate1  dd ?
      GLOBAL indicate2  dd ?
      GLOBAL indicate3  dd ?
      GLOBAL indicate4  dd ?

      GLOBAL processor  dd ?
      GLOBAL osversion  dd ?
      GLOBAL working    dd ?

      .if uMsg == WM_INITDIALOG
        m2m hWnd, hWin    ; Copy hWin to GLOBAL variable
        invoke SendMessage,hWin,WM_SETTEXT,0,ADDR dlgTitle
        invoke SendMessage,hWin,WM_SETICON,1,FUNC(LoadIcon,hInstance,5)

      ; --------------------------------
      ; Get the handle for each control
      ; --------------------------------
        mov hButn1,    rv(GetDlgItem,hWin,102)
        mov hButn2,    rv(GetDlgItem,hWin,103)         ; close button

      ; --------------------
      ; progress bar handles
      ; --------------------
        mov bar1,      rv(GetDlgItem,hWin,201)
        mov bar2,      rv(GetDlgItem,hWin,202)
        mov bar3,      rv(GetDlgItem,hWin,203)
        mov bar4,      rv(GetDlgItem,hWin,204)

      ; ---------------------
      ; algorithm name labels
      ; ---------------------
        mov algoname1, rv(GetDlgItem,hWin,105)
        mov algoname2, rv(GetDlgItem,hWin,106)
        mov algoname3, rv(GetDlgItem,hWin,107)
        mov algoname4, rv(GetDlgItem,hWin,108)

      ; -----------------------
      ; indicator radio buttons
      ; -----------------------
        mov indicate1, rv(GetDlgItem,hWin,110)
        mov indicate2, rv(GetDlgItem,hWin,111)
        mov indicate3, rv(GetDlgItem,hWin,112)
        mov indicate4, rv(GetDlgItem,hWin,113)
      ; -----------------------

        mov rslt1,     rv(GetDlgItem,hWin,301)
        mov rslt2,     rv(GetDlgItem,hWin,302)
        mov rslt3,     rv(GetDlgItem,hWin,303)
        mov rslt4,     rv(GetDlgItem,hWin,304)

        mov processor, rv(GetDlgItem,hWin,401)
        mov osversion, rv(GetDlgItem,hWin,402)
        mov working,   rv(GetDlgItem,hWin,999)

      ; -------------------------------------
      ; set the algorithm names to each label
      ; -------------------------------------
        fn SetWindowText,algoname1,nam1
        fn SetWindowText,algoname2,nam2
        fn SetWindowText,algoname3,nam3
        fn SetWindowText,algoname4,nam4

      ; ---------------------------------
      ; get the CPUID string if supported
      ; ---------------------------------

        pushad
        pushfd

        .if rv(is_cpuid) != 0
          mov pbuf, ptr$(buffer)
          invoke get_cpu_id_string,pbuf
          mov pbuf, rv(szMonoSpace,pbuf)
        .else
          sas pbuf, "CPUID not supported"
        .endif

        popfd
        popad

      ; ---------------------------------

        fn SetWindowText,processor,pbuf

        xor eax, eax
        ret

      .elseif uMsg == WM_COMMAND
        .if wParam == 102
          invoke run_benchmarks

        .elseif wParam == 103
          jmp outa_here

        .endif

      .elseif uMsg == WM_CLOSE
        outa_here:
        invoke EndDialog,hWin,0

      .endif

    xor eax, eax
    ret

WndProc endp

; 

load_common_controls proc

    LOCAL icce:INITCOMMONCONTROLSEX

  ; --------------------------------------
  ; comment out the styles you don't need.
  ; --------------------------------------
    mov icce.dwSize, SIZEOF INITCOMMONCONTROLSEX            ; set the structure size
    xor eax, eax                                            ; set EAX to zero
    or eax, ICC_ANIMATE_CLASS                               ; OR as many styles as you need to it
    or eax, ICC_BAR_CLASSES                                 ; comment out the rest
    or eax, ICC_COOL_CLASSES
    or eax, ICC_DATE_CLASSES
    or eax, ICC_HOTKEY_CLASS
    or eax, ICC_INTERNET_CLASSES
    or eax, ICC_LISTVIEW_CLASSES
    or eax, ICC_PAGESCROLLER_CLASS
    or eax, ICC_PROGRESS_CLASS
    or eax, ICC_TAB_CLASSES
    or eax, ICC_TREEVIEW_CLASSES
    or eax, ICC_UPDOWN_CLASS
    or eax, ICC_USEREX_CLASSES
    or eax, ICC_WIN95_CLASSES
    mov icce.dwICC, eax
    invoke InitCommonControlsEx,ADDR icce                   ; initialise the common control library

    ret

load_common_controls endp

; 

get_cpu_id_string proc pBuffer:DWORD

    push ebx
    push esi

    mov esi, pBuffer                    ; load buffer address into ESI
   
    mov eax, 80000002h                  ; extended function 2
    cpuid

    mov [esi],    eax                   ; write results to buffer
    mov [esi+4],  ebx
    mov [esi+8],  ecx
    mov [esi+12], edx

    mov eax, 80000003h                  ; extended function 3
    cpuid

    mov [esi+16], eax                   ; write results to buffer
    mov [esi+20], ebx
    mov [esi+24], ecx
    mov [esi+28], edx

    mov eax, 80000004h                  ; extended function 4
    cpuid

    mov [esi+32], eax                   ; write results to buffer
    mov [esi+36], ebx
    mov [esi+40], ecx
    mov [esi+44], edx

    mov [esi+48], DWORD PTR 0           ; terminate result

    pop esi
    pop ebx

    ret

get_cpu_id_string endp

; 

is_cpuid proc

    pushfd
    pop eax

    mov ecx, eax
    xor eax, 00000000001000000000000000000000b          ; set bit 21
    push eax
    popfd
    pushfd
    pop eax

    xor eax, ecx            ; test if its changed
    jz NotChanged
    mov eax, 1              ; returns 1 if CPUID is present
    ret

  NotChanged:
    xor eax, eax            ; returns 0 if its not
    ret

is_cpuid endp

; 

indicate proc arg1:DWORD

  ; -----------
  ; uncheck all
  ; -----------
    invoke SendMessage,indicate1,BM_SETCHECK,BST_UNCHECKED,0
    invoke SendMessage,indicate2,BM_SETCHECK,BST_UNCHECKED,0
    invoke SendMessage,indicate3,BM_SETCHECK,BST_UNCHECKED,0
    invoke SendMessage,indicate4,BM_SETCHECK,BST_UNCHECKED,0

  ; --------------
  ; check selected
  ; --------------
    .if arg1 == 1
      invoke SendMessage,indicate1,BM_SETCHECK,BST_CHECKED,0
    .elseif arg1 == 2
      invoke SendMessage,indicate2,BM_SETCHECK,BST_CHECKED,0
    .elseif arg1 == 3
      invoke SendMessage,indicate3,BM_SETCHECK,BST_CHECKED,0
    .elseif arg1 == 4
      invoke SendMessage,indicate4,BM_SETCHECK,BST_CHECKED,0
    .endif

  ; --------------
  ; update display
  ; --------------
    invoke SendMessage,indicate1,WM_PAINT,0,0
    invoke SendMessage,indicate2,WM_PAINT,0,0
    invoke SendMessage,indicate3,WM_PAINT,0,0
    invoke SendMessage,indicate4,WM_PAINT,0,0

    ret

indicate endp

; 

    iterate equ <10000000>

run_benchmarks proc

    LOCAL pbuf  :DWORD
    LOCAL buffer[128]:BYTE

    LOCAL dbuf  :DWORD
    LOCAL dbuffr[128]:BYTE

    LOCAL tm1   :DWORD
    LOCAL tm2   :DWORD
    LOCAL tm3   :DWORD
    LOCAL tm4   :DWORD

    LOCAL av1   :DWORD
    LOCAL av2   :DWORD
    LOCAL av3   :DWORD
    LOCAL av4   :DWORD

    LOCAL range :DWORD
    LOCAL pcnt  :DWORD
    LOCAL hFile :DWORD

    push ebx
    push esi
    push edi

    invoke ShowWindow,hButn1,SW_HIDE
    invoke ShowWindow,hButn2,SW_HIDE

  ; -------------------------------------------
  ; clear the progress bars and trailing labels
  ; -------------------------------------------
    invoke SendMessage,bar1,PBM_SETPOS,0,0
    invoke SendMessage,bar2,PBM_SETPOS,0,0
    invoke SendMessage,bar3,PBM_SETPOS,0,0
    invoke SendMessage,bar4,PBM_SETPOS,0,0

    fn SetWindowText,rslt1,0
    fn SetWindowText,rslt2,0
    fn SetWindowText,rslt3,0
    fn SetWindowText,rslt4,0

    mov pbuf, ptr$(buffer)

  ; ----------------
  ; CALIBRATION CODE
  ; ----------------
    fn SetWindowText,working,"Calibrating Algorithms"

  ; ==========================

    invoke indicate,1

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    mov tm1, eax

  ; ==========================

    invoke indicate,2

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa_ex,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    mov tm2, eax

  ; ==========================

    invoke indicate,3

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke udw2str,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    mov tm3, eax

  ; ==========================

    invoke indicate,4

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    mov pbuf, ustr$(esi)
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    mov tm4, eax

  ; ==========================

    mov eax, tm1
    mov ecx, tm2
    mov edx, tm3

  ; ----------------------------------------------
  ; calculate the longest time of the slowest algo
  ; ----------------------------------------------
    mov range, eax
    .if ecx > range
      mov range, ecx
    .endif

    .if edx > range
      mov range, edx
    .endif

    mov eax, tm4
    .if eax > range
      mov range, eax
    .endif

  ; ---------------------------------------------------------
  ; add 50% to it to improve the display of the progress bars
  ; ---------------------------------------------------------
    mov eax, range
    shr eax, 1
    add range, eax

    invoke indicate,0

  ; ----------------------------------
  ; set the range of the progress bars
  ; ----------------------------------
    invoke SendMessage,bar1,PBM_SETRANGE32,0,range
    invoke SendMessage,bar2,PBM_SETRANGE32,0,range
    invoke SendMessage,bar3,PBM_SETRANGE32,0,range
    invoke SendMessage,bar4,PBM_SETRANGE32,0,range

    fn SetWindowText,working,"Calibrating pass results"

  ; ----------------------------------
  ; write the calibration pass results
  ; ----------------------------------
    invoke SendMessage,bar1,PBM_SETPOS,tm1,0
    invoke SendMessage,bar2,PBM_SETPOS,tm2,0
    invoke SendMessage,bar3,PBM_SETPOS,tm3,0
    invoke SendMessage,bar4,PBM_SETPOS,tm4,0

    fn SetWindowText,rslt1,str$(tm1)
    fn SetWindowText,rslt2,str$(tm2)
    fn SetWindowText,rslt3,str$(tm3)
    fn SetWindowText,rslt4,str$(tm4)

  ; ---------------------------
  ; clear the average variables
  ; ---------------------------
    mov av1, 0
    mov av2, 0
    mov av3, 0
    mov av4, 0

  ; ---------------------
  ; zero the pass counter
  ; ---------------------
    mov pcnt, 0

  ; ------------------
  ; The BENCHMARK CODE
  ; ------------------
  REPEAT 8

    add pcnt, 1
    mov dbuf, ptr$(dbuffr)
    mov dbuf, cat$(dbuf,"Timing pass ",str$(pcnt))
    fn SetWindowText,working,dbuf

  ; ==========================

    invoke indicate,1

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add av1, eax

    invoke SleepEx,100,0

  ; ==========================

    invoke indicate,2

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa_ex,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add av2, eax

    invoke SleepEx,100,0

  ; ==========================

    invoke indicate,3

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke udw2str,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add av3, eax

    invoke SleepEx,100,0

  ; ==========================

    invoke indicate,4

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    mov pbuf, ustr$(esi)
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add av4, eax

    invoke SleepEx,100,0

  ; ==========================

  ENDM

    fn SetWindowText,working,"Average results for 8 passes. RESULTS written to bmlog.txt"

  ; -----------------------------------
  ; divide results by 8 to get averages
  ; -----------------------------------
    shr av1, 3
    shr av2, 3
    shr av3, 3
    shr av4, 3

  ; ----------------------------------------------
  ; write results to both progress bars and labels
  ; ----------------------------------------------
    invoke SendMessage,bar1,PBM_SETPOS,av1,0
    invoke SendMessage,bar2,PBM_SETPOS,av2,0
    invoke SendMessage,bar3,PBM_SETPOS,av3,0
    invoke SendMessage,bar4,PBM_SETPOS,av4,0

    fn SetWindowText,rslt1,str$(av1)
    fn SetWindowText,rslt2,str$(av2)
    fn SetWindowText,rslt3,str$(av3)
    fn SetWindowText,rslt4,str$(av4)

    invoke indicate,0

  ; ------------------------
  ; get the processor string
  ; ------------------------
    mov pbuf, ptr$(buffer)
    fn GetWindowText,processor,pbuf,128

  ; ------------------
  ; WRITE THE LOG FILE
  ; ------------------
    mov hFile, fcreate("bmlog.txt")

    fprint hFile,pbuf
    fprint hFile,"Results 8 pass average"
   
    mov dbuf, ptr$(dbuffr)
    mov dbuf, cat$(dbuf,"timing utoa       ",ustr$(av1)," ms")
    fprint hFile,dbuf

    mov dbuf, ptr$(dbuffr)
    mov dbuf, cat$(dbuf,"timing utoa_ex    ",ustr$(av2)," ms")
    fprint hFile,dbuf

    mov dbuf, ptr$(dbuffr)
    mov dbuf, cat$(dbuf,"timing udw2str    ",ustr$(av3)," ms")
    fprint hFile,dbuf

    mov dbuf, ptr$(dbuffr)
    mov dbuf, cat$(dbuf,"timing vcrt ustr$ ",ustr$(av4)," ms")
    fprint hFile,dbuf

    fclose hFile

    invoke ShowWindow,hButn1,SW_SHOW
    invoke ShowWindow,hButn2,SW_SHOW

    pop edi
    pop esi
    pop ebx

    ret

run_benchmarks endp

; 

end start

